--[[

Stage 1
Title: City on Home Planet

This is a LUA script for the Game called "NewoShooter"

VISIT THE "NEWO SHOOTER" PAGE ON HTTP://WWW.WIIBREW.ORG FOR MORE INFO
DEVELOPED BY OWEN ( HTTP://WWW.OWENSOFT.NET )


Hopefully this way I can get other people to help build stages and interactions.
I may add new features and options to the API, check the game's on the wiibrew.org wiki

This is probably the easiest type of stage to create.  It made up of a table containing
the position of the primary buildings, bosses and the enemies.  Then it randomly adds
clouds, grass and extra buildings to fill up the environment.

Version: 1
Game Version: 1.65

--]]

--system

ge = {} --game environment variables

--object types
 NOTHING= 0
 BUILDING= 1
 ENEMY= 2
 MYSHIP= 3
 METEOR= 4
 ASTEROID= 5
 MINE= 6
 BOSS= 7
 BOSSMINI= 8
 CLOUD= 9
 LEVELEND= 10
 GRASS= 11
 PLAYER= 12
 TUNNEL= 13
 TERRAIN= 14
 BRIDGE=15

--primary colours
 GRRLIB_BLACK   =0x000000FF
 GRRLIB_MAROON  =0x800000FF
 GRRLIB_GREEN   =0x008000FF
 GRRLIB_OLIVE   =0x808000FF
 GRRLIB_NAVY    =0x000080FF
 GRRLIB_PURPLE  =0x800080FF
 GRRLIB_TEAL    =0x008080FF
 GRRLIB_GRAY    =0x808080FF
 GRRLIB_SILVER  =0xC0C0C0FF
 GRRLIB_RED     =0xFF0000FF
 GRRLIB_LIME    =0x00FF00FF
 GRRLIB_YELLOW  =0xFFFF00FF
 GRRLIB_BLUE    =0x0000FFFF
 GRRLIB_FUCHSIA =0xFF00FFFF
 GRRLIB_AQUA    =0x00FFFFFF
 GRRLIB_WHITE   =0xFFFFFFFF


--[[
Add stuff to the level, run once
--]]

function level_setup()

	game_reset();  --reset the game engine to blank

	ge.stage_has_floor=true;
	ge.stage_floor_color=GRRLIB_GREEN;
	ge.stage_gravity=-5;  --how fast enemies fall
	ge.effect_landinglights=true; --there are a few effects, only set the ones you need
	ge.effect_stardust_color=0xFFFFFFFF;

	--note that the game moves from 0 down the negative z axis usually to -45000
	--if you set the z axis to 1000, it will be off screen and looped back to -45000 (ge.max_z)
	--note: changing the z-axis will have no effect unless you modify the code in the loop
	level_mapinfo={
		{300,0,-400, BUILDING, 0}, {-200,0,-800, BUILDING, 0}, {150,0,-300, BUILDING, 0},
		{-300,0,-600, ENEMY, 0},{130,100,-500, BUILDING, 1 },{130,100,-500, BRIDGE, 0 },
		{150,0,-700, BUILDING, 0},{-300,0,-500, ENEMY, 0},{150,0,-900, BUILDING, 0},
		{-118,0,-1100, BUILDING, 0},{210,0,-500, BUILDING, 0},{-410,0,-200, BUILDING, 0},
		{410,0,-200, ENEMY, 0},{-180,0,-200, BUILDING, 1},{180,0,-200, BUILDING, 2},
		{200,0,-300, BUILDING, 2},{150,0,-150, BUILDING, 0},{-150,0,-150, BUILDING, 0},{130,100,-500, BRIDGE, 0 },
		{150,0,-350, BUILDING, 0},{-50,0,-350, BUILDING, 2},{-50,120,-350, BOSS, 2},

		{300,10,-100, BUILDING, 0}, {-200,80,-800, BUILDING, 0}, {150,0,-200, BUILDING, 0},
		{-300,0,-600, ENEMY, 0},{130,100,-400, BUILDING, 1 },{130,100,-500, BRIDGE, 0 },
		{150,0,-700, BUILDING, 2},{-300,0,-500, ENEMY, 0},{150,0,-900, BUILDING, 0},
		{-118,0,-1100, BUILDING, 0},{210,-100,-500, BUILDING, 0},{-410,0,-200, BUILDING, 0},
		{410,0,-200, ENEMY, 0},{-180,0,-200, BUILDING, 1},{180,0,-200, BUILDING, 2},
		{200,0,-300, BUILDING, 1},{150,180,-150, BUILDING, 2},{-150,0,-150, BUILDING, 0},
		{150,-110,-350, BUILDING, 0},{-50,120,-350, BOSS, 2}, {210,0,-5250, BUILDING, 0},
		{-50,120,-350, BRIDGE, 0 },
	};

	c=0
	spacing=1000
	arr_count=#level_mapinfo
	for  k,v in pairs(level_mapinfo) do
		if v[5] == nil then v[5]=0; end
		set_obj_type( c, v[4], v[5] );
		--I got lazy so I just placed the buildings evenly down the lenght of the map
		--instead of manually using v[3] to hard code their position, which i had originally planned
		--function set_obj_point( obj_index, x pos, y pos, z pos);
		set_obj_point( c, v[1], v[2], spacing+((ge.max_z/arr_count) * c ) );
		set_obj_active( c, true);
		c=c+1
	end


	--fill the rest of the array with clouds, grass and enemys
	--ge.obj_max returns the upper bound of my object array, this is fixed
	--the engine wil crash if you go pass it
	for i=arr_count,ge.obj_max,1 do
		t=math.random(1,3);
		z=-math.random(-1000, -ge.max_z);
		if t == 1 then
			set_obj_type( i, CLOUD, math.random(0,2) );
		end
		if t == 2 then
			set_obj_type( i, BUILDING, math.random(0,2) );
			set_obj_point( i, math.random(-2500,2500), math.random(-500, 500), math.random(ge.max_z,0) ); --place at rand position
		end
		if t == 3 then
			set_obj_type( i, GRASS, 0 );
		end

		--grass and clouds are automagically randomized in game_int but this can be changed

		set_obj_active(i, true); --make object active
	end

	-- put the level end marker at the end of the stage ( ge.max_z ) which is -45000 by default
	-- put it further to extend the length of the stage.  if it is not set the stage loops forever
	-- set_obj_q( obj_index, obj_type, x pos, y pos, z pos )
	set_obj_q( ge.obj_max-1, LEVELEND, 0, 0, ge.max_z );

	game_init()  --init the game and you are done

end --stage setup


--[[
monitor the level, run every frame
--]]

function level_render()

	--currently not used

end
